/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.GolonganPegawai;
import com.portofolio.entity.vo.GolonganPegawaiId;

@Lazy
@Repository
public interface GolonganPegawaiDao extends CrudRepository<GolonganPegawai, GolonganPegawaiId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaGolonganPegawai like %:namaGolonganPegawai% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaGolonganPegawai") String namaGolonganPegawai, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdGolonganPegawai = :kdGolonganPegawai")
	Map<String, Object> findByKdGolonganPegawai(@Param("kdProfile") Integer kdProfile,@Param("kdGolonganPegawai") Integer kdGolonganPegawai, @Param("statusEnabled") boolean statusEnabled);

	String QListAll = "select new map(model.id.kdGolonganPegawai as kdGolonganPegawai,model.id.kdProfile as kdProfile "
			+ ", model.namaGolonganPegawai as namaGolonganPegawai, model.kdGolonganPegawaiHead as kdGolonganPegawaiHead "
			+ ", model.reportDisplay as reportDisplay " + ", model.noUrut as noUrut  "
			+ ", model.kodeExternal as kodeExternal " + ", model.namaExternal as namaExternal "
			+ ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " 
			+ ", model.version as version )"
			+ " from GolonganPegawai model left join model.id id where id.kdProfile=:kdProfile  and model.statusEnabled = :statusEnabled ";



}
